﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace SpeechCast
{
    public class CaptionFont
    {
        public string Name = "MS UI Gothic";
        public float Size = 30;
        public int BorderSize = 3;
        public bool Italic = false;
        public bool Bold = false;

        public CaptionFont()
        {
        }

        public CaptionFont(CaptionFont captionFont)
        {
            Name = captionFont.Name;
            Size = captionFont.Size;
            BorderSize = captionFont.BorderSize;
            Italic = captionFont.Italic;
            Bold = captionFont.Bold;
        }

        public Font CreateFont()
        {
            FontStyle fs = FontStyle.Regular;

            if (Italic)
            {
                fs |= FontStyle.Italic;
            }
            if (Bold)
            {
                fs |= FontStyle.Bold;
            }

            //Size = (float)((int)Size);
            return new Font(Name, Size, fs);
        }
    }
}
